;****************************************************
; Gestion des ressources GEM
;****************************************************

	include backup.hs

trans_hex_deci:
	ext.l d0
	divu #10,d0
	add.b #'0',d0
	move.b d0,(a1)+
	swap d0
	add.b #'0',d0
	move.b d0,(a1)+
	rts

init_rsc:	lea add_options,a0
	move.w #OPTIONS,d0
	bsr get_addr_tree

	move.w #DESCRIPTIF_SET,d0
	lea add_tree,a0
	bsr get_addr_tree

	move.l add_tree,a0
	move.w #TEXT_DESCRIPT,d0
	mulu #L_OBJECT,d0
	move.l ob_spec(a0,d0.l),a2
	move.w #64+1,te_txtlen(a2)	; ruse pour le descriptif

	clr d7
	rts

 DATA 
conversion:
	dc.w $1,ADD_BCK_MENU
	dc.w $2,BCK_MENU
	dc.w $3,CSTCT_SET_MENU
	dc.w $9,INFO_DISK_MENU
	dc.w $f,OPTIONS_MENU
	dc.w $11,QUIT_MENU	
	dc.w $12,RST_ALL_MENU
	dc.w $13,RST_SELC_MENU
	dc.l 0
 TEXT
*------------------------------------------------------------------------
;O	P	T	I	O	N	S
*------------------------------------------------------------------------
FORM_OPTIONS:
	move.l add_options,a0

	move.w #RECUR_YES_OPT,d0	; YES puis NO sinon plante!!!!!!
	mulu #L_OBJECT,d0
	move.w recurse_subdirs,d1
	move.w d1,ob_state(a0,d0.l)
	bchg #0,d1
	move.w d1,ob_state+L_OBJECT(a0,d0.l)

	move.w #INC_YES_OPT,d0
	mulu #L_OBJECT,d0
	move.w save_entire_path,d1
	move.w d1,ob_state(a0,d0.l)
	bchg #0,d1
	move.w d1,ob_state+L_OBJECT(a0,d0.l)

	move.w #DEL_YES_OPT,d0
	mulu #L_OBJECT,d0
	move.w delete_after_bck,d1
	move.w d1,ob_state(a0,d0.l)
	bchg #0,d1
	move.w d1,ob_state+L_OBJECT(a0,d0.l)

	move.w #DISA_YES_OPT,d0
	mulu #L_OBJECT,d0
	move.w disable_warnings,d1
	move.w d1,ob_state(a0,d0.l)
	bchg #0,d1
	move.w d1,ob_state+L_OBJECT(a0,d0.l)

	move.w #VER_YES_OPT,d0
	mulu #L_OBJECT,d0
	move.w total_verify,d1
	move.w d1,ob_state(a0,d0.l)
	bchg #0,d1
	move.w d1,ob_state+L_OBJECT(a0,d0.l)

	form_center add_options

	move.l int_out+2,form_x
	move.l int_out+6,form_w

	graf_mouse #256
	form_dial #0,#0,#0,#0,#0,form_x,form_y,form_w,form_h
	form_dial #1,#0,#0,#10,#10,form_x,form_y,form_w,form_h
	objc_draw add_options,#0,#12,form_x,form_y,form_w,form_h
	graf_mouse #257
	graf_mouse #0

	form_do add_options,#0		; pas de champs ditable
	save d0
	objc_change add_options,d0,form_x,form_y,form_w,form_h,#0,#0
	load d0

	cmp.w #CANCEL_OPT,d0
	beq.s cancel_opti

	move.l add_options,a0

	move.w #RECUR_YES_OPT,d0
	mulu #L_OBJECT,d0
	move.w ob_state(a0,d0.l),recurse_subdirs

	move.w #INC_YES_OPT,d0
	mulu #L_OBJECT,d0
	move.w ob_state(a0,d0.l),save_entire_path

	move.w #DEL_YES_OPT,d0
	mulu #L_OBJECT,d0
	move.w ob_state(a0,d0.l),delete_after_bck

	move.w #DISA_YES_OPT,d0
	mulu #L_OBJECT,d0
	move.w ob_state(a0,d0.l),disable_warnings

	move.w #VER_YES_OPT,d0
	mulu #L_OBJECT,d0
	move.w ob_state(a0,d0.l),total_verify

cancel_opti:graf_mouse #256
	form_dial #2,#0,#0,#10,#10,form_x,form_y,form_w,form_h
	form_dial #3,#0,#0,#0,#0,form_x,form_y,form_w,form_h
	graf_mouse #257
	graf_mouse #0

	rts

*------------------------------------
;I	N	F	O
*------------------------------------
INFORMATION:move.w #INFORMATIONS,d0
	bsr traite_formulaire
	rts

*------------------------------------------------------------------------
;E	R	R	E	U	R	S
*------------------------------------------------------------------------
enter_descriptif:
	move.w #DESCRIPTIF_SET,d0
	bsr traite_formulaire

	move.l add_tree,a0
	move.w #TEXT_DESCRIPT,d0
	bsr get_text_add

	lea descriptif,a2
	move.w #64,d0
	move.w d0,(a2)+
	subq.w #1,d0
.recop_txt:	move.b (a1)+,(a2)+
	dbf d0,.recop_txt
	
	rts
*---------------------------------
informe_user:
	clr d7
	tst disable_warnings
	bne.s .continue

	move.w #DATA_ON_DISK,d0
	bsr traite_formulaire

	clr d7

	cmp.w #CONT_WDATA,d0
	beq.s .continue
	move.w #-200,d7
.continue	rts
*---------------------------------
error_write:save d0-d6/a0-a6

	move.w #WRITE_ERROR,d0
	lea add_tree,a0
	bsr get_addr_tree

	move.l add_tree,a0

	move.w #NB_SIDES_WE,d0
	bsr get_text_add
	move.w zone_tampon,d0
	add.b #'0',d0
	move.b d0,(a1)

	move.w #NB_TRK_WE,d0
	bsr get_text_add
	move.w zone_tampon+2,d0
	bsr trans_hex_deci

	move.w #NB_SEC_TRK_WE,d0
	bsr get_text_add
	move.w zone_tampon+4,d0
	bsr trans_hex_deci

	move.w #WRITE_ERROR,d0
	bsr traite_formulaire

	clr d7
	cmp.w #RETRY_WE,d0
	beq.s .fin
	cmp.w #NEW_WE,d0
	beq.s .new_disk
	cmp.w #FORMAT_WE,d0
	beq.s .format
	move #-200,d7
.fin:	load d0-d6/a0-a6
	rts
.new_disk:	move.w #-202,d7
	bra.s .fin
.format:	move.w #-207,d7
	bra.s .fin
active_retry:
	move.w #WRITE_ERROR,d0
	lea add_tree,a0
	bsr get_addr_tree

	move.l add_tree,a0

	move.w #RETRY_WE,d0
	mulu #L_OBJECT,d0
	bclr #3,ob_state+1(a0,d0.l)
	rts
desactive_retry:
	move.w #WRITE_ERROR,d0
	lea add_tree,a0
	bsr get_addr_tree

	move.l add_tree,a0

	move.w #RETRY_WE,d0
	mulu #L_OBJECT,d0
	bset #3,ob_state+1(a0,d0.l)
	rts
*---------------------------------
erreur_mem:	
	save d0
	move.w #MEMORY_ERROR,d0
	bsr traite_formulaire
	
	load d0
	rts
*---------------------------------
FORM_INFO_DISK:
	save d0-a6

	move.w #INFO_ON_DISK,d0
	lea add_tree,a0
	bsr get_addr_tree

	move.l add_tree,a0

	move.w #DESC_IOD,d0
	bsr get_text_add
	lea if_not_a_guw_bck_disk,a2
	moveq #64-1,d0
.cp:	move.b (a2)+,(a1)+
	dbf d0,.cp

	move.w #FATHER_IOD,d0
	mulu #L_OBJECT,d0
	bset #7,ob_flags+1(a0,d0.l)	; invisible

	bsr is_dis_a_bck_dsk
	tst d7
	bmi .not_bck

	move.l add_tree,a0

	move.w #FATHER_IOD,d0
	mulu #L_OBJECT,d0
	bclr #7,ob_flags+1(a0,d0.l)	; visible

	move.w #DESC_IOD,d0
	bsr get_text_add
	lea 2+$1c+desc_boot-debut_boot+boot_secteur,a2
	moveq #64-1,d0
.cp1:	move.b (a2)+,(a1)+
	dbf d0,.cp1

	move.w #DAY_IOD,d0
	bsr get_text_add
	lea 2+$1c+name_report-debut_boot+boot_secteur,a2
	move.b (a2)+,(a1)+
	move.b (a2)+,(a1)+

	move.w #MONTH_IOD,d0
	bsr get_text_add
	move.b (a2)+,(a1)+
	move.b (a2)+,(a1)+

	move.w #HOURS_IOD,d0
	bsr get_text_add
	move.b (a2)+,(a1)+
	move.b (a2)+,(a1)+

	move.w #MINUTES_IOD,d0
	bsr get_text_add
	move.b (a2)+,(a1)+
	move.b (a2)+,(a1)+

	move.w #DISK_NR_IOD,d0
	bsr get_text_add
	move boot_secteur+512-2,d0
	sub.w #'00',d0
	bsr trans_hex_deci

	move.w #LAST_IOD,d0
	mulu #L_OBJECT,d0
	bclr #7,ob_flags+1(a0,d0.l)	; visible
	
	cmp.l #'LAST',boot_secteur+512-2-4-4
	beq.s .not_bck
	move.w #LAST_IOD,d0
	mulu #L_OBJECT,d0
	bset #7,ob_flags+1(a0,d0.l)	; invisible

.not_bck:			; en commun : format du disque.

	move.l add_tree,a0

	move.w #NB_SIDES_IOD,d0
	bsr get_text_add
	move.w nb_faces,d0
	add.b #'0',d0
	move.b d0,(a1)

	move.w #NB_TRACKS_IOD,d0
	bsr get_text_add
	move.w nb_pistes,d0
	bsr trans_hex_deci

	move.w #NB_SECTRK_IOD,d0
	bsr get_text_add
	move.w nb_sec_pistes,d0
	bsr trans_hex_deci


	move.w #INFO_ON_DISK,d0
	bsr traite_formulaire

	load d0-a6
	rts
*---------------------------------
its_same_set:save d0
	move.w #SET_ON_DISK,d0
	bsr traite_formulaire

	load d0
	rts
*---------------------------------
not_same_f:	save d0
	move.w #NOT_GOOD_FORMAT,d0
	bsr traite_formulaire

	load d0
	rts
*---------------------------------
not_right_v:save d0
	move.w #NOT_RIGHT_VER,d0
	bsr traite_formulaire

	load d0
	rts
*---------------------------------
dnot_exist:	save d0
	move.w #SET_DOES_NOT_EX,d0
	bsr traite_formulaire

	load d0
	rts
*---------------------------------
warning_exist:
	move.w #ALREADY_EXIST,d0
	lea add_tree,a0
	bsr get_addr_tree

	move.l add_tree,a0

	move.w #TEXT_ALE,d0
	bsr get_text_add

	lea user_path,a0
.p0:	tst.b (a0)+
	bne.s .p0

.p1:	cmp.b #'\',-(a0)
	beq.s .aa
	cmp.l #user_path,a0
	beq.s .bb
	bra.s .p1
.aa:	lea 1(a0),a0
.bb:
.p00:	move.b (a0)+,(a1)+
	tst.b -1(a1)
	bne.s .p00

	move.w #ALREADY_EXIST,d0
	bsr traite_formulaire

	clr d7
	cmp.w #SKIP_1_ALE,d0
	beq.s .fin
	cmp.w #SKIP_ALL_ALE,d0
	beq.s .saut_tous
	cmp.w #OVER_1_ALE,d0
	beq.s .eff
	cmp.w #OVER_ALL_ALE,d0
	beq.s .eff_tous
	move #-200,d7
.fin:	rts
.eff:	moveq #2,d7			; 2 efface
	rts
.eff_tous:	moveq #2,d7			; 2 efface
	move.w d7,tous_fich
	rts
.saut_tous:	clr d7
	move.w d7,tous_fich
	rts
*---------------------------------
err_lect:	move.w #READ_ERROR,d0
	bsr traite_formulaire

	clr d7
	cmp.w #RETRY_RE,d0
	beq.s .fin
	move.w #-200,d7
	cmp.w #NEXT_RE,d0
	bne.s .fin
	move.w #-207,d7
.fin:	rts
active_next:
	move.w #READ_ERROR,d0
	lea add_tree,a0
	bsr get_addr_tree

	move.l add_tree,a0

	move.w #NEXT_RE,d0
	mulu #L_OBJECT,d0
	bclr #3,ob_state+1(a0,d0.l)
	rts
desactive_next:
	move.w #READ_ERROR,d0
	lea add_tree,a0
	bsr get_addr_tree

	move.l add_tree,a0

	move.w #NEXT_RE,d0
	mulu #L_OBJECT,d0
	bset #3,ob_state+1(a0,d0.l)
	rts
*---------------------------------
err_lect_bios:
	move.w #READ_ERROR_BIOS,d0
	bsr traite_formulaire

	clr d7
	cmp.w #RETRY_REB,d0
	beq.s .fin
	move.w #-200,d7
.fin:	rts
*---------------------------------
warning:	move.w #INSERT_DISK,d0
	lea add_tree,a0
	bsr get_addr_tree

	move.l add_tree,a0

	move.w #NUM_INSERT,d0
	bsr get_text_add
	move num_disk,d0
	bsr trans_hex_deci

	move.w #CURRENT_INSERT,d0
	bsr get_text_add
	move disque_courant,d0
	bne.s .pas_0
	move.b #'_',(a1)+
	move.b #'_',(a1)
	bra.s .insert_d
.pas_0:	bsr trans_hex_deci
.insert_d:
	move.w #INSERT_DISK,d0
	bsr traite_formulaire

	clr d7
	cmp.w #OK_INSERT,d0
	beq.s .fin
	move.w #-200,d7
.fin:	rts
*---------------------------------
please_insert_last_disk:
	move.w #INSERT_LAST,d0
	lea add_tree,a0
	bsr get_addr_tree

	move.l add_tree,a0
	move.w #CURRENT_LAST,d0
	bsr get_text_add
	move disque_courant,d0
	bne.s .pas_0
	move.b #'_',(a1)+
	move.b #'_',(a1)
	bra.s .insert_d
.pas_0:	bsr trans_hex_deci
.insert_d:
	move.w #INSERT_LAST,d0
	bsr traite_formulaire

	clr d7
	cmp.w #OK_LAST,d0
	beq.s .fin
	move.w #-200,d7
.fin:	rts
	
*---------------------------------
err_ver:	save d0
	move.w #VERIFY_ERROR,d0
	bsr traite_formulaire
	load d0
	rts
err_mem_ver:save d0
	move.w #VERIFY_MEM_ERROR,d0
	bsr traite_formulaire
	load d0
	rts
*------------------------------------------------------------------------

 DATA
window1:	dc.w 1
	dc.w %00111001001
	dc.w 64,100		; interne physique
	dc.w 64,10		; taille max
	dc.w -1,0
	dc.w 64,10		; taille  l'ouverture
	dc.l title_set

window2:	dc.w 1
	dc.w %00111001001
	dc.w 77,200		; interne physique
	dc.w 77,10		; taille max
	dc.w -1,50
	dc.w 77,10		; taille  l'ouverture
	dc.l title_texte

title_texte	dc.b 'Comments : ',0
title_set	dc.b 'List of available sets : ',0

if_not_a_guw_bck_disk:
	dc.b 'This Disk does not belong to a Genuwax Total backup Set',0

	ifeq QUI
name_rsc:	dc.b 'd:\assemble\sources.guw\totalbck\backup.rsc',0
	endc
	ifeq QUI-2
name_rsc:	dc.b 'd:\devpac\source\genuwax\backup.rsc',0
	endc
 even
 BSS
index_window1:ds.w 1
index_window2:ds.w 1

add_options:ds.l 1

 TEXT
